// filling.cpp - area filling routines for xonix

#include "filling.h"

bool enemyFound = false;
bool result1 = true;
bool result2 = true;
bool result3 = true;
bool result4 = true;
int  i;					// counter

///////////////////////////////////////////////////////////////

void FillOccupied()
{
	// finds an empty spot and fills the area it belongs to
	// with marker using flood-fill algorithm
	// if no enemy is encountered while filling with marker
	// it fills the same area with the color of occupied
	// territory

	int  x, y;
	int  xPos, yPos;
	bool foundEmpty = true;
	static int numDump = 0;
	
	// make trail a part of occupied territory
	for (y = 0; y < NUM_BLOCK_ROWS; y++)
		for (x = 0; x < NUM_BLOCK_COLUMNS; x++)
			if (blocks[x][y] == TRAIL)
				blocks[x][y] = OCCUPIED;

	while (foundEmpty)
	{
		foundEmpty = false;
		for (y = 0; y < NUM_BLOCK_ROWS; y++)
		{
			for (x = 0; x < NUM_BLOCK_COLUMNS; x++)
				if (blocks[x][y] == FREE)
				{
					xPos = x;
					yPos = y;
					foundEmpty = true;
					break;
				}
			if (foundEmpty)
				break;
		}
		
		enemyFound = false;
		MarkArea(xPos, yPos, MARKER);
		if (foundEmpty && !enemyFound)
			FillArea(xPos, yPos);
	}

	// clean up unoccupied areas (remove marker) and count occupied blocks
	numOccupied = 0;
	for (y = 0; y < NUM_BLOCK_ROWS; y++)
		for (x = 0; x < NUM_BLOCK_COLUMNS; x++)
		{
			if (blocks[x][y] == MARKER)
				blocks[x][y] = FREE;
			if (blocks[x][y] == OCCUPIED)
				numOccupied++;
		}
}


///////////////////////////////////////////////////////////////

void MarkArea(int x, int y, UCHAR code)
{
	if (blocks[x][y] != FREE)			// hit the border
		return;

	blocks[x][y] = code;				// put the code in the block

	MarkArea(x + 1, y, code);
	MarkArea(x - 1, y, code);
	MarkArea(x, y - 1, code);
	MarkArea(x, y + 1, code);


	for (i = 0; i < numBugs; i++)
		if (x == bug[i].x && y == bug[i].y)	// check if we are filling an
			enemyFound = true;

	return;
}


///////////////////////////////////////////////////////////////

void FillArea(int x, int y)
{
	// fill area marked with MARKER using flood-fill algorithm
	if (blocks[x][y] != MARKER)
		return;
	blocks[x][y] = OCCUPIED;
	FillArea(x + 1, y);
	FillArea(x - 1, y);
	FillArea(x, y - 1);
	FillArea(x, y + 1);
}


///////////////////////////////////////////////////////////////

void ClearTrail()
{
	for (int y = 1; y < NUM_BLOCK_ROWS - 1; y++)
		for (int x = 1; x < NUM_BLOCK_COLUMNS - 1; x++)
			if (blocks[x][y] == TRAIL)
				blocks[x][y] = FREE;
}
                                                                                                                                                                                                                                                                                                                   