// global.h - global defines and external declarations

#ifndef GLOBAL_H
#define GLOBAL_H


typedef unsigned char UCHAR;


#define WINDOW_WIDTH            640     // size of window
#define WINDOW_HEIGHT           480


// block defines
#define BLOCK_WIDTH             10
#define BLOCK_HEIGHT            10
#define BLOCK_ORIGIN_X          0
#define BLOCK_ORIGIN_Y          0
#define NUM_BLOCK_ROWS          (WINDOW_HEIGHT / BLOCK_HEIGHT - 2)
#define NUM_BLOCK_COLUMNS       (WINDOW_WIDTH / BLOCK_WIDTH)
#define NUM_BLOCKS				(NUM_BLOCK_ROWS * NUM_BLOCK_COLUMNS)
#define NUM_BUG_FRAMES			12
#define NUM_BONUS_FRAMES		7
#define NUM_LIFE_FRAMES			6

#define NUM_LEVELS				10

// color defines
#define BALL					250
#define ENEMY					127
#define SPIDER					79
#define OCCUPIED				158
#define FREE					60
#define TRAIL					221
#define MARKER					150

#define MAX_COLORS_PALETTE   256


extern UCHAR blocks[NUM_BLOCK_COLUMNS][NUM_BLOCK_ROWS];
extern int enemy_x;
extern int enemy_y;			// tracks position of enemy
extern int numBugs;

extern struct anim_struct
{
	int x;
	int y;
	int dx;
	int dy;
	int frame;
} bug[NUM_LEVELS], spider[NUM_LEVELS], bonus, life, heart;

typedef struct BITMAP_FILE_TAG		BITMAP_FILE;
typedef struct IDirectDrawSurface7	*LPDIRECTDRAWSURFACE7;

extern BITMAP_FILE				bitmap;		// holds the bitmap
extern LPDIRECTDRAWSURFACE7		lpddsBall;
extern LPDIRECTDRAWSURFACE7		lpddsSpider;
extern LPDIRECTDRAWSURFACE7		lpddsBG;
extern LPDIRECTDRAWSURFACE7		lpddsHeart;
extern LPDIRECTDRAWSURFACE7		lpddsBug[NUM_BUG_FRAMES];
extern LPDIRECTDRAWSURFACE7		lpddsBonus[NUM_BONUS_FRAMES];
extern LPDIRECTDRAWSURFACE7		lpddsLife[NUM_LIFE_FRAMES];

extern int numOccupied;		// tracks number of blocks occupied


#endif
